 /*
 Created By:
 Jonathan Markovits 311233522
 Itay Feiner 204271936
 */


#define BLYNK_PRINT SerialUSB
#define BLYNK_DEBUG SerialUSB

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>
#include <TimeLib.h>
#include <WidgetRTC.h>

char auth[] = "ltR5Q0NapcefbhSpzG6bUOOu1VfS5_5P";
char ssid[] = "Alon 1";
char pass[] = "0523701394";

#define EspSerial Serial1
#define ESP8266_BAUD 115200

ESP8266 wifi(&EspSerial);

WidgetLCD lcd(V2);
WidgetRTC rtc;
BlynkTimer timer;

int feedBtn = 0;
int delaySec = 0;
int amountOfFood = 0;
unsigned long previousMillis = 0;

void setup() {
  CircuitPlayground.begin();
  SerialUSB.begin(9600);
  EspSerial.begin(ESP8266_BAUD);
  delay(10);
  Blynk.begin(auth, wifi, ssid, pass);
  lcd.clear();
  setSyncInterval(10 * 60);
  
  pinMode(A1, OUTPUT);
}

void loop() {
  Blynk.run();
  timer.run();

  printToLcd();
}

void feed() {
  if (feedBtn && millis() - previousMillis >= delaySec) {
    previousMillis = millis();
    digitalWrite(A1, HIGH);
    delay(amountOfFood);
    makeSound();
    sendTime();
  } else {
    digitalWrite(A1, LOW);
  }
}

void makeSound() {
  for (int i = 440; i < 1760; i += 100) {
    CircuitPlayground.playTone(i, 100);
  }
}

void sendTime() {
  String currentTime = String("Time: ") + hour() + ":" + minute() + ":" + second() + ", Date: " + day() + "/" + month() + "/" + year();
  Blynk.virtualWrite(V4, currentTime);
}

void printToLcd() {
  lcd.print(0, 0, "Delay for:");
  lcd.print(0, 1, "                     ");
  lcd.print(0, 1, max((delaySec - (int)(millis() + previousMillis)) / 1000, 0));
}

BLYNK_CONNECTED() {
  rtc.begin();
}

BLYNK_WRITE(V0) {
  delaySec = param.asInt() * 60000;
}

BLYNK_WRITE(V1) {
  amountOfFood = param.asInt() * 2000;
}

BLYNK_WRITE(V3) {
  feedBtn = param.asInt();
  feed();
}
